//
//  MyImageCapture.h

#import <AVFoundation/AVFoundation.h>
#import <Cocoa/Cocoa.h>

@class MyiSightWindow, SampleCIView, QTCaptureSession;

@interface MyImageCapture : NSObject <AVCaptureVideoDataOutputSampleBufferDelegate> {
	
	IBOutlet MyiSightWindow *previewWindow;
	IBOutlet SampleCIView *previewView;
	IBOutlet NSButton *pauseButton;
	//IBOutlet NSButton *rotateClockwiseButton;
	IBOutlet NSSlider *cropSlider;

	//id delegate;
	//BOOL mirrored;
	BOOL paused; //, clockwise;
	CGFloat cropSidesAmount;
	
	CIImage *originalCaptureCIImage;
	
	QTCaptureSession *mCaptureSession;

	CIFilter *scaleFilter;
	CIFilter *rotateFilter, *translateFilter;
	CIFilter *leftCropFilter, *rightCropFilter;

	CGFloat previousX, previousY;
    
    AVCaptureSession *captureSession;
}
@property (retain, atomic) AVCaptureSession *captureSession;
@property (strong, nonatomic) NSArray *topLevelObjects;


- (IBAction)setImageForSelection:(id)sender;

- (void)captureCoverImageForSelection;

- (IBAction)tooglePause:(id)sender;
//- (IBAction)toggleMirroredImage:(id)sender;

- (IBAction)scaleImage:(id)sender;
- (IBAction)rotateImage:(id)sender;

- (void)translateImageXBy:(CGFloat)anX yBy:(CGFloat)aY;
- (IBAction)cropSides:(id)sender;

//- (IBAction)clockwiseRotate:(id)sender;

@end
