//
//  MyPreferencesShared.h
//  Pediabase
//
//  Created by Conor Dearden on 20/8/07.
//  Copyright 2007 Chiguire LLC. All rights reserved.
//

#import <Cocoa/Cocoa.h>
	
@class MyController, MyPluginManager, MyComboBoxDataShared, MyAmazon;
	//!!! Animate changing tabs
@interface MyPreferencesShared : NSObject <NSToolbarDelegate>
{
	IBOutlet NSWindow *preferenceWindow;
	IBOutlet NSView *generalView;
	//IBOutlet NSView *detailsView;
	IBOutlet NSView *styleView;
	IBOutlet NSView *pluginView;
	IBOutlet NSView *emailView;
	IBOutlet NSView *autoFillView;
	IBOutlet NSView *addPanelView;
    IBOutlet NSMatrix *bottomFieldMatrix;
	IBOutlet NSTextField *folderPathView;
	IBOutlet NSSlider *coverBackground;
	IBOutlet NSButton *coverBorder;
	IBOutlet NSButton *checkForUpdates;
	
	IBOutlet NSPopUpButton *webViewStyle;
	
	IBOutlet NSTableView *pluginTable;
	
	IBOutlet NSTextField *dateFormat;
	IBOutlet NSTextField *dateFormatR;
	IBOutlet NSTextField *dateFormatT;
	
	IBOutlet NSPopUpButton *autoFillPopUp;
	IBOutlet NSTableView *autoFillTable;
	
	//IBOutlet NSMatrix *displayInInfoMatrix;
	//IBOutlet NSMatrix *activeFields;
	
	IBOutlet NSTextField *subjectBorrower;
	IBOutlet NSTextView *bodyBorrower;
	IBOutlet NSTextField *subjectFriend;
	IBOutlet NSTextView *bodyFriend;	
	
	IBOutlet NSTableView *fieldOptionsTable;
	IBOutlet NSPopUpButton *fieldOptionsPopUp;

	IBOutlet NSPopUpButton *collectionSize;
	IBOutlet NSPopUpButton *entryTableSize;
	
	MyComboBoxDataShared *comboBoxData;	
	NSString *selectedAutoFillString;
	//NSMutableArray *editFields, *detailsFields;
	
	BOOL mailerWasOn;
    MyAmazon *amazon;
}

- (void)openPreferences;

- (IBAction)changePrefView:(id)sender;
- (IBAction)helpButtonClick:(id)sender;

- (IBAction)changeCollectionSize:(id)sender;
- (IBAction)changeEntryTableSize:(id)sender;


- (IBAction)PopUpChanging:(id)sender;
- (IBAction)autoFillAddEmptyRow:(id)sender;
- (IBAction)autoFillDeleteRow:(id)sender;
- (IBAction)webViewStyleChanging:(id)sender;

- (IBAction)rebuildSelectedAutofill:(id)sender;
//- (IBAction)openPreferenceForPlugin:(id)sender;

- (void)windowDidResignKey:(NSNotification *)aNotification;

- (void)setupAutofillTab;

+ (NSString *)otherDateFormat;

- (IBAction)configureAmazonSettings:(id)sender;

@end
