/* MyWebView */

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>

enum {
    MKWebViewSpecialView = 1,
    MKWebViewNothingSelected,
    MKWebViewStatisticsView,
    MKWebViewEntryView,
    MKWebViewLinkView,
    MKWebViewURL,
    MKWebViewEpub,
    MKWebViewDiscoGSAuth
};
typedef NSUInteger MKWebView;


@class MyWebSplitView, MyTransparentWindow, MyControllerShared, MOLink; //, MyWebHeader;

@interface MyWebView : WKWebView <WKUIDelegate, WKNavigationDelegate, WKScriptMessageHandler> {
	@private
	IBOutlet MyWebSplitView *webSplitView;
	IBOutlet MyControllerShared *controller;
	IBOutlet NSMenu *styleMenu;

	//WebHeaderViews.xib
	IBOutlet NSView *statisticsHeader;
	IBOutlet NSView *urlHeader;
	IBOutlet NSTextField *urlTextField;
	//IBOutlet NSButton *previousArrowButton;
	//IBOutlet NSButton *nextArrowButton;
	
	NSMutableString *templateStructure;
	NSString *templateHeader;

	NSString *locale, *selectedTemplate, *webViewFiles; 
	MOLink *lastLink; //, *coverImageFolder, *dataFolderPath;
	//NSString *languageLocale;
	MOEntry *lastSelectedEntry;
	// for go to site window
	//MyTransparentWindow *displayWindow;
	NSURL *templateURL;
	
	NSBundle *frameworkBundle;
	//NSString *previousStatisticsString;
	NSMutableString *noSelection;
	
	NSUInteger lastViewType;
	
	BOOL viewingLinks;
    
    NSMutableArray *epubLinks;
    NSUInteger epubCurrentItem;
    BOOL findVerifier;
    //WKNavigation *loadingNavigation;
	//BOOL viewingCollection;
    
    NSUInteger numberOfHistoryItems;
}

@property (assign, nonatomic) NSUInteger lastViewType;
@property (strong, nonatomic) WKNavigation *loadingNavigation;
@property (strong, nonatomic) NSURL *URLToLoad;
@property (strong, nonatomic) WKNavigation *navigationToStartAnimation;
@property (strong, nonatomic) NSURL *dataFolderURL;
@property (strong, nonatomic) NSURL *tempDetailsURL;
@property (strong, nonatomic) NSString *lastMouseOverLink;

@property (strong, nonatomic) NSArray *topLevelObjects;

//@property (nonatomic, strong) MyBackForwardList* customBackForwardList;

//@property (strong, nonatomic) NSMenu *contextualMenu;

- (void)addFromURL:(id)sender;
- (void)makeSummary:(id)sender;
- (void)makeImageCover:(id)sender;
- (void)goToSite:(id)sender;
//- (void)setURL:(NSString *)urlString;

//- (IBAction)checkForUpdate:(id)sender;

- (void)displaySelectionForced:(BOOL)forced;
- (void)MyInit;
- (void)changeTemplate:(id)sender;
//- (BOOL)getViewingLinks;
//- (void)setViewingLinks:(BOOL)aBool;

- (void)exitFullscreen:(id)sender;
- (IBAction)statistics:(id)sender;
- (IBAction)showLinks:(id)sender;


- (void)loadLink:(NSString *)url internalLink:(BOOL)internal;
//- (void)goToSiteClose:(id)sender;

- (MOEntry *)lastSelectedEntry;
- (MyWebSplitView *)enclosingSplitView;

- (void)addToStyleMenu:(NSString *)aFolder;
- (NSArray *)stylesMenuItems;


//Debug "Show Details View HTML" option help menu
- (IBAction)showHTML:(id)sender;

- (IBAction)goToWebsite:(id)sender;
- (IBAction)configureStats:(id)sender;

- (IBAction)nextArrowClicked:(id)sender;
- (IBAction)previousArrowClicked:(id)sender;

@end
